from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, Int, Float

Barriers_Rna2_V0_1_0 = CommandToolBuilder(tool="barriers_RNA2", base_command=["barriers-RNA2"], inputs=[ToolInput(tag="in_full_help", input_type=Boolean(optional=True), prefix="--full-help", doc=InputDocumentation(doc="Print help, including hidden options, and exit")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="be quiet, inhibit PS output  (default=off)")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="print more information  (default=off)")), ToolInput(tag="in_graph", input_type=String(optional=True), prefix="--graph", doc=InputDocumentation(doc="define graph type  (default=`RNA')")), ToolInput(tag="in_moves", input_type=String(optional=True), prefix="--moves", doc=InputDocumentation(doc="select move-set (if Graph allows several different\nones)")), ToolInput(tag="in_b_size", input_type=Boolean(optional=True), prefix="--bsize", doc=InputDocumentation(doc="print basin sizes  (default=off)")), ToolInput(tag="in_s_size", input_type=Boolean(optional=True), prefix="--ssize", doc=InputDocumentation(doc="print saddle component sizes  (default=off)")), ToolInput(tag="in_max", input_type=Int(optional=True), prefix="--max", doc=InputDocumentation(doc="compute only the lowest <num> local minima\n(default=`100')")), ToolInput(tag="in_minh", input_type=Float(optional=True), prefix="--minh", doc=InputDocumentation(doc="print only minima with barrier > dE\n(default=`0.000001')")), ToolInput(tag="in_saddle", input_type=Boolean(optional=True), prefix="--saddle", doc=InputDocumentation(doc="print saddle point structures  (default=off)")), ToolInput(tag="in_rates", input_type=Boolean(optional=True), prefix="--rates", doc=InputDocumentation(doc="compute rates between macro states (basins)\n(default=off)")), ToolInput(tag="in_poset", input_type=Int(optional=True), prefix="--poset", doc=InputDocumentation(doc="input is a poset from n objective functions\n(default=`0')")), ToolInput(tag="in_path", input_type=Int(optional=True), prefix="--path", doc=InputDocumentation(doc="=<l2>  backtrack path between lmins l2 and l1 (l1 < l2),\ncan be specified multiple times")), ToolInput(tag="in_sb_map", input_type=Boolean(optional=True), prefix="--sbmap", doc=InputDocumentation(doc="FK: output map of structures and their respective")), ToolInput(tag="in_trans", input_type=Boolean(optional=True), prefix="--trans", doc=InputDocumentation(doc="FK: output a list of all transient structures and their")), ToolInput(tag="in_basins", input_type=String(), position=0, doc=InputDocumentation(doc="(default=off)")), ToolInput(tag="in_neighbors", input_type=String(), position=1, doc=InputDocumentation(doc="(default=off)")), ToolInput(tag="in_rna", input_type=String(), position=0, doc=InputDocumentation(doc="RNA secondary structures")), ToolInput(tag="in_rna_no_lp", input_type=String(), position=1, doc=InputDocumentation(doc="canonical RNA structures\n[no]Shift       with/out shift moves [default with]")), ToolInput(tag="in_rna_two", input_type=Int(), position=2, doc=InputDocumentation(doc="RNA secondary structures\n[no]Shift       with/out shift moves [default with]")), ToolInput(tag="in_rna_two_no_lp", input_type=Int(), position=3, doc=InputDocumentation(doc="canonical RNA structures, no lonely pairs\n[no]Shift       with/out shift moves [default with]")), ToolInput(tag="in_q_two", input_type=Int(), position=4, doc=InputDocumentation(doc="Spin Glass\np               point mutation (default)\nc               flip 2nd half")), ToolInput(tag="in_nni", input_type=String(), position=0, doc=InputDocumentation(doc="NNI moves [no other options yet]"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Barriers_Rna2_V0_1_0().translate("wdl", allow_empty_container=True)

